/**
 * @since:2014-7-29
 * @author:u.ken.li@qq.com 
 * @
 */
// 核心
var TF = {
	// 遮罩
	Mask : {
		cfg : {
			id		: ".kMask"												// 盒子
		},
		// show
		show : function (n) {
			var oMask = $(this.cfg.id);						// 遮罩层

			if(!oMask.length) {
				var bTran = n==0 ? "kMask tran" : "kMask";
				oMask = $('<div class="'+ bTran +'" />').appendTo($("body"));
				oMask
					.height($(document).height())
					.click( function(){
						// handler
					//	TF.Mask.hide();
					});
			}
		},
		// hide
		hide : function () {
			$(this.cfg.id)
				.remove();
		}		
	},

	// 弹出
	Popup : {
		cfg : {
			id		: ".kPopup",											// 盒子
			speed	: 200
		},
		// show
		show : function (sTitle) {
			var oPopup = $(this.cfg.id);
			if(!oPopup.length) {
				oPopup = $('<div class="kPopup" />').appendTo($("body"));
				oTitle = $('<div class="title" />').appendTo(oPopup);
				oTitle.html(sTitle);
				oClose = $('<a href="javascript:void(0)" class="close" />').prependTo(oPopup);
				oClose
					.html("x")
					.click(function(){
						TF.Popup.hide();
					});
				
				$('<div class="kPopupC" />').appendTo(oPopup);
			}
		},
		// hide
		hide : function () {
			$(this.cfg.id)
				.remove();
		}
	},
	
	// 泡泡
	Bubble : {
		cfg : {
			id		: ".kBubble",										// 盒子
			speed	: 2000
		},
		show : function(str){
			var oBubble = $(this.cfg.id);
			var sTitle = str;
			if(!oBubble.length) {
				oBubble = $('<div class="kBubble" />').appendTo($("body"));
				oBubble.html(sTitle).fadeIn();		
			}
			TF.Mask.show(0);		
			setTimeout("TF.Bubble.hide()", TF.Bubble.cfg.speed);
		},
		hide : function(){
			$(this.cfg.id).fadeOut("slow", function(){
				$(this).remove();
				TF.Mask.hide();
			});
		}
	},
	
	// 对话框
	Dialog : {
		cfg : {
			id					: ".kDlg",											// 盒子
			box					: ".kDlgC",											
			hasTitle		: true,
			title				: "提示信息",
			btn					: ["确定"]
		},
		// show
		show : function(){
			var oDlg = $(this.cfg.id);
			var sTitle = this.cfg.title;

			if(!oDlg.length) {
				oDlg = $('<div class="kDlg" />').appendTo($("body"));
				if (this.cfg.hasTitle)	{
					oTitle = $('<div class="title" />').appendTo(oDlg);
					oTitle.html(sTitle);
				}
				$('<div class="kDlgC" />').appendTo(oDlg);
				$('<div class="kDlgBtn" />').appendTo(oDlg);
			}			
			this.addBtn();
			oDlg.show();
			TF.Mask.show();
		},		
		// add btn
		addBtn : function(){
			var oBtn = $(".kDlgBtn");
			oBtn.empty();

			// 逆序排序
			$.each( this.cfg.btn, function(i, n){
				$('<a href="javascript:void(0)">'+n+'</a>').prependTo(oBtn);
			});

			if (this.cfg.btn.length>1) $(".kDlgBtn>a").width("50%");
		},
		// hide
		hide : function(){
			$(this.cfg.id)
				.remove();
			TF.Mask.hide();
		}
	},

	// 加载...
	Loading : {
		cfg : {
			id		: ".kLoading"
		},
		// show
		show : function (msg) {
			var oLoading = $(this.cfg.id);
			var sMsg = msg == undefined ? "请等待..." : msg;

			if(!oLoading.length) {
				oLoading = $('<div class="kLoading" />').appendTo($("body"));
				oLoading
					.html("<i></i>"+
								"<p>"+ sMsg +"</p>");				
			}
			TF.Mask.show(0);
		},
		// hide
		hide : function () {
			$(this.cfg.id)
				.remove();
			TF.Mask.hide();
		}
	},
	
	// 模拟 Radio
	kRadio : function(el) {
		if ($(".radio input").length){			
			$(".radio").removeClass("radio_checked");
			$(".radio input:checked").parent("label").addClass("radio_checked");
		}
		if (el) {
			var sName = $(el).children("input").attr("name");
			$(".radio input[name="+ sName +"]").attr("checked", false);
			$(el).children("input").attr("checked", true);
		}
	},
	
	// 模拟 Checkbox
	kCheckbox : function(el){
		var o = $(el).children("input");
		o.attr("checked", o.attr("checked") ? false : true);
		if($(".checkbox input").length){
			$(".checkbox").removeClass("checkbox_checked");
			$(".checkbox input:checked").parent("label").addClass("checkbox_checked");
		}
	},
	
	// 模拟 switch
	kSwitch : function(){
		// switch
		$(".switchOff, .switchOn")
			.live("click", function(){
				var el = $(this);
				// default
				el.attr("class", 
					el.attr("class")=="switchOff" 
					? 
					"switchOn"
					:
					"switchOff"
				);				
			});
		
		// switch abc
		$(".switchAbcOff, .switchAbcOn")
			.live("click", function(){
				var el = $(this);
				// abc
				el.attr("class", 
					el.attr("class")=="switchAbcOff" 
					? 
					"switchAbcOn"
					:
					"switchAbcOff"
				);			
			});
	},
	
	// 模拟 select
	kSelect : {
		cfg : {
			id	: ".kPopup",
			box : ".kPopupC"
		},
		// 设置默认
		def : function(el){
			// 
		},
		// 创建列表项
		show : function(el, ds){
			var el = $(el);
			var sTitle = el.attr("title");
			var nIndex = el.attr("data-val");

			TF.Popup.show(sTitle);
			
			var oPopup = $(this.cfg.id);
			var oPopupC = $(this.cfg.box);

			var aDs = ds;

			var oBox = $(aDs[0].src 
									? '<ul class="PMList image-text clearfix" />' 
									: '<ul class="PMList clearfix" />');

			$.each(aDs, function(i){				
				var bIsCurrent = nIndex == aDs[i].val ? ' class="current"' : '';
				
				if (aDs[i].src){
					$('<li data-val='+ aDs[i].val
							+ bIsCurrent 
							+'><img src="'+ aDs[i].src +'" />'
							+ aDs[i].text 
							+	'</li>')
						.appendTo(oBox);
				}else{
					$('<li data-val='+ aDs[i].val
							+ bIsCurrent +'>'
							+ aDs[i].text 
							+'</li>')
						.appendTo(oBox);
				}
			});

			var oList = oBox.find("li");
			oList.click(function(){
				el.html($(this).html()).attr("data-val", $(this).attr("data-val"));
				el.removeClass("placeholder");
				oList.removeClass("current");
				$(this).addClass("current");
				TF.Popup.hide();
			});

			oPopupC.html(oBox);
			oPopup.slideDown(TF.Popup.cfg.speed);	
		}		
	},
	
	//省、市、区选择
	Pcd : {
		cfg : {
			id					: "#pcd",
			province		: "#province",
			city				: "#city",
			district		: "#district",
			pcdProvince	: "#pcdProvince",
			pcdCity			: "#pcdCity",
			pcdDistrict : "#pcdDistrict"
		},	
		province : function(){
			var aData = jsonProvince;
			var sDef = $(this.cfg.pcdProvince).val();
			var sCur = "";

			$.each(aData, function(i, n){
				sCur = aData[i].code == sDef ? ' class="current"' : "";
				 $('<li data-val=' + aData[i].code + sCur + '>' + aData[i].name + '</li>')
					 .appendTo($(TF.Pcd.cfg.province));
			});

			$(this.cfg.province + ">li")
				.live("click", function(){
					$(TF.Pcd.cfg.pcdProvince).val( $(this).attr("data-val"));
					$(this).parent().find("li").attr("class", "");
					$(this).attr("class", "current");

					TF.Pcd.city();
					TF.Pcd.district();
				});	
		},
		city : function(){
			var aData = jsonCity;
			var sDef = $(this.cfg.pcdCity).val();
			var sCur = "";
			var nParentCode = $(this.cfg.province +" li[class='current']").attr("data-val").substring(0, 2);
			
			$(this.cfg.city).empty();
			$.each(aData, function(i, n){			
				if (nParentCode == aData[i].code.substring(0, 2)) {
					sCur = aData[i].code == sDef ? ' class="current"' : "";

					$('<li data-val=' + aData[i].code + sCur + '>' + aData[i].name + '</li>')
						.appendTo($(TF.Pcd.cfg.city));
				}			 
			});

			$(this.cfg.city + ">li")
				.live("click", function(){
					$(TF.Pcd.cfg.pcdCity).val( $(this).attr("data-val"));
					$(this).parent().find("li").attr("class", "");
					$(this).attr("class", "current");

					TF.Pcd.district();
				});

			if ($(this.cfg.city + ">li[class='current']").length<=0){
				$(this.cfg.pcdCity).val( $(this.cfg.city + ">li:first").attr("data-val"));
				$(this.cfg.city + ">li:first").addClass("current");
			}
		},
		district : function(){
			var aData = jsonDistrict;
			var sDef = $(this.cfg.pcdDistrict).val();
			var nParentCode = $(this.cfg.city +" li[class='current']").attr("data-val").substring(0, 4);
			var sCur = "";
			
			$(this.cfg.district).empty();
			$.each(aData, function(i, n){			
				if (nParentCode == aData[i].code.substring(0, 4)) {
					sCur = aData[i].code == sDef ? ' class="current"' : "";

					$('<li data-val=' + aData[i].code + sCur + '>' + aData[i].name + '</li>')
						.appendTo($(TF.Pcd.cfg.district));
				}			 
			});

			if ($(this.cfg.district + ">li[class='current']").length<=0){
				$(this.cfg.pcdDistrict).val( $(this.cfg.district + ">li:first").attr("data-val"));
				$(this.cfg.district + ">li:first").addClass("current");
			}

			$(this.cfg.district + ">li")
				.live("click", function(){
					
					$(TF.Pcd.cfg.pcdDistrict).val( $(this).attr("data-val"));
					$(this).parent().find("li").attr("class", "");
					$(this).attr("class", "current");
					
					var sPcd = $(TF.Pcd.cfg.province + ">li[class='current']").text() + $(TF.Pcd.cfg.city + ">li[class='current']").text() + $(TF.Pcd.cfg.district + ">li[class='current']").text();
					$(TF.Pcd.cfg.id).html(sPcd);
					
					
					setTimeout("TF.Popup.hide()", 200);
				});
		},	
		init : function(){
			this.province();
			this.city();
			this.district();

			$(".pcd").click(function(){});		
		}
	},
	
	// 手机号分段显示
	cellPhoneSegment : function(){

		$(".jCellPhone")
			.live("keyup", function(e){
				var o = $(this);
				var sVal = $.trim(o.val()).replace(/\s/g, '');
				var aNum = sVal.match(/./g);
				var nLen = sVal.length;
				var sNum = "";

				nLen>0 
					? o.addClass("txt-segment") 
					: o.removeClass("txt-segment");

				for (i=0; i<aNum.length; i++){
					if (i==3 || i==7 ){
						sNum = sNum + " " + aNum[i];
					}else{
						sNum = sNum + aNum[i];
					}
				}				
				o.val( sNum );
			});	
	},
	
	// 银行卡分段显示
	bankCardSegment : function(){
		$(".jBankCard")
			.live("keyup", function(e){
				var o = $(this);
				var sVal = $.trim(o.val()).replace(/\s/g, '');
				var aNum = sVal.match(/./g);
				var nLen = sVal.length;
				var sNum = "";

				nLen>0 
					? o.addClass("txt-segment") 
					: o.removeClass("txt-segment");

				for (i=0; i<aNum.length; i++){
					if (i==4 || i==8 || i==12 || i==16 || i==20 ){
						sNum = sNum + " " + aNum[i];
					}else{
						sNum = sNum + aNum[i];
					}
				}				
				o.val( sNum );				
			});
	},

	// upload
	uploadID : function(el){
		var sTitle = $(el).attr("title");				
		this.Popup.hide();
		this.Popup.show(sTitle);
		var oPopup = $(".kPopup");
		var oPopupC = $(".kPopupC");
		oPopupC
			.addClass("uploadBox")
			.html(
				'<div class="uploadSel clearfix">'+	
				'	<a href="javascript:void(0)"><i></i>相册</a>'+	
				'	<a href="javascript:void(0)"><i></i>拍照</a>'+	
				'</div>'
			);
		oPopup.slideDown(this.Popup.cfg.speed);
	},
	
	// 客服电话
	serviceTel : function(){
		var o = $(".service-tel");
		var bdH = $("body").height() + o.height();
		var wndH = $(document).height();

		var sPos = bdH >= wndH ? "relative" : "fixed";
		o.css("position", sPos);	
	},
	
	// 是否有底部
	hasFooter : function(){
		var o = $(".content");
		if ($("footer").size()>0) o.addClass("cf");
	},

	// 更多数据
	loadMore : {
		cfg : {
			id			: ".content",		// 载入数据对象
			dh			: 0,		// 初始
			loading	: false		
		},
				
		// 加载数据
		show : function(obj, data){
			var extraH = $("footer").height();
			this.cfg.dh	= parseFloat($(window).height()) + parseFloat($(window).scrollTop()); 

			if (( $(this.cfg.id).height() - extraH) <= this.cfg.dh)
			{
				this.cfg.loading = true;

				//加载数据
				obj.append(data);
			}
			
		}
	},

	// 初始化
	init : function(){
		
		// 模拟 Checkbox
		$(".checkbox:not('.disabled')")
		 .live("click", function(){
				TF.kCheckbox(this);
			});
		// 模拟 Radio
		$(".radio")
		 .live("click", function(){
				TF.kRadio(this);
			});
		this.kCheckbox();
		this.kRadio();
		
		this.kSwitch();									// Switch				
		this.cellPhoneSegment();				// 手机分段
		this.bankCardSegment();					// 银行卡分段
		this.serviceTel();
		this.hasFooter();								// 是否有底									
//	this.Loading.show();
	}
};

$(document)
 .ready(function(){
		TF.init(); 
	});
$(window)
	.resize(function(){
		TF.serviceTel();
	})
	.scroll(function(){
		TF.serviceTel();
	});